using System;
using System.Collections.Generic;
using System.Linq;
using System.Text.RegularExpressions;

class FindHolidays
{
	static void Main() 
	{
		Console.WriteLine("\n\n");
		
		string text = "Last year 24.12.2015, 25.12.2015 and 31.12.2015 were very nice holidays, because they were on weekdays (work days). This year, however, is particularly unfortunate, since all of 24.12.2016, 25.12.2016 and 31.12.2016 are during weekends.";

		// Extract Christmas or New Year's Eve dates from text and check whether they are in a leap year
		Regex.Matches(text, @"(25|31)\.12\.\d{2}(\d{2})").Cast<Match>().
			Where(match => (int.Parse(match.Groups[2].Value) % 4 == 0)).
				ForEach(match => Console.WriteLine("Christian holiday during leap year found: " + match.Value + "\n"));
				
		Console.WriteLine("\n\nPress ENTER to exit.");
		Console.ReadKey();
	}
}

// Extending the IEnumerable<T> interface with a ForEach method (like the one from List<T>)
public static class IEnumerableExtensions
{
	public static void ForEach<T>(this IEnumerable<T> iEnumerable, Action<T> action)
	{
		foreach(T item in iEnumerable)	action(item);
	}
}
