var wu = require('./node_modules/wu/wu');	// Uses wu.js module

console.log("\n\n");

// Define extension method for RegExp that iterates all matches
RegExp.prototype.AllMatches = 
	function*(input)
	{
		var match = this.exec(input);
		while (match != null)
		{
			yield match;
			match = this.exec(input);
		}
	}

var text = "Last year 24.12.2015, 25.12.2015 and 31.12.2015 were very nice holidays, because they were on weekdays (work days). This year, however, is particularly unfortunate, since all of 24.12.2016, 25.12.2016 and 31.12.2016 are during weekends.";

// Extract dates from text and check whether they are Christmas or New Year's Eve in leap year
wu(/(25|31)\.12\.\d{2}(\d{2})/g.AllMatches(text)).
	filter(match => parseInt(match[2]) % 4 == 0).
		forEach(match => console.log("Christian holiday during leap year found: " + match[0] + "\n"));

console.log("\n\nPress ENTER to exit.");
process.stdin.setRawMode(true);
process.stdin.resume();
process.stdin.on('data', process.exit.bind(process, 0));
