import msvcrt

from itertools import *

print("\n\n")

# An infinite generator of the Fibonacci sequence
def Fibonacci():
	(current, next) = (0, 1)
	while True:
		yield current
		(current, next) = (next, current + next)

# An infinite generator of the Lazy caterer's sequence
def LazyCaterer():
	index = 0
	while True:
		yield (index * index + index + 2) / 2
		index += 1

# An infinite generator of the Catalan sequence
def Catalan():
	index = 0
	current = 1
	while True:
		yield current
		current = current * (4 * index + 2) / (index + 2)
		index += 1
		
# Syntactical sugar meant to ease the retrieval of all elements from a sequence that are smaller to a given limit
def LessThan(sequence, limit):
	return takewhile(lambda number: number <= limit, sequence())

# Find all numbers smaller than 1000000000 that are Fibonacci, Lazy caterer's and Catalan at the same time
for number in set(LessThan(Fibonacci, 1000000000)) & set(LessThan(LazyCaterer, 1000000000)) & set(LessThan(Catalan, 1000000000)):
	print(number)
	
print("\n\nPress ENTER to exit.")
msvcrt.getch()
