import java.io.IOException;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.AbstractMap.SimpleEntry;
import java.util.HashSet;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;
import java.util.stream.Collectors;
import java.util.stream.Stream;
import java.util.stream.StreamSupport;

class MaxFunction
{
    public static void main(String args[])
    {
        System.out.println("\n\n");

        Map<Double, Double> function1 = CreateMap(
			MapEntry(15.2d, 204d), MapEntry(1d, 1d), MapEntry(19d, 4d), MapEntry(75d, 1001d), MapEntry(3.1415d, 666d), 
			MapEntry(7d, 8d), MapEntry(11d, 45.12d), MapEntry(1.3d, 6d), MapEntry(78.24d, 6658.1d), MapEntry(0.001d, 200d));
        Map<Double, Double> function2 = CreateMap(
			MapEntry(42d, 42d), MapEntry(1d, 17d), MapEntry(19d, 0.56d), MapEntry(75d, 1001d), MapEntry(2.72d, 747d), 
			MapEntry(7d, 88d), MapEntry(10.9d, 77.9d), MapEntry(0.001d, 200.001d));

        // Take all entries from the first funtion that have greater result than the corresponding entries from the second function or have no corresponding entry there
        Set<Entry<Double,Double>> maximalEntries = 
			function1.entrySet().stream().
				filter(entry -> function2.getOrDefault(entry.getKey(), function1.get(entry.getKey())) <= function1.get(entry.getKey())).
					collect(Collectors.toCollection(HashSet::new));
        // Add all entries from the second funtion that have greater result than the corresponding entries from the first function or have no corresponding entry there
        maximalEntries.addAll(
			function2.entrySet().stream().
				filter(entry -> function1.getOrDefault(entry.getKey(), function2.get(entry.getKey())) <= function2.get(entry.getKey())).
					collect(Collectors.toCollection(HashSet::new)));

        Map<Double, Double> max = CreateMap(maximalEntries);
        System.out.println("The resulting new function is:");
        max.entrySet().stream().forEach(
			entry -> System.out.println("\t" + entry.getKey() + " -> " + entry.getValue()));

        System.out.println("\n\nPress ENTER to exit.");
        try
        {
            BufferedReader systemInReader = new BufferedReader(new InputStreamReader(System.in));
            int enter = systemInReader.read();
        }
        catch(IOException exception)    {}
    }

    // Utility method meant to ease the declaration of maps
    static Map<Double, Double> CreateMap(Entry<Double, Double>... entries)
    {
		return Stream.of(entries).collect(Collectors.toMap(Entry::getKey, Entry::getValue));
    }

    // Utility method meant to ease the declaration of maps
    static Map<Double, Double> CreateMap(Set<Entry<Double,Double>> entries)
    {
		return entries.stream().collect(Collectors.toMap(Entry::getKey, Entry::getValue));
    }

    // Syntactic sugar meant to ease the declaration of map entries
    static SimpleEntry<Double, Double> MapEntry(Double key, Double value)
    {
        return new SimpleEntry<Double, Double>(key, value);
    }
}
