console.log("\n\n");

// Extends the Map object with method that determines whether the function, represented by the map, is monotonically increasing
// It is required that the keys and the values in the Map are numbers
Map.prototype.IsMonotonicallyIncreasing = 
	function()
	{
		var keys = Array.from(this.keys());
		return keys.every(key1 => keys.every(key2 => key1 >= key2 || this.get(key1) < this.get(key2)));
	}

// Extends the Map object with method that determines whether the function, represented by the map, is monotonically decreasing
// It is required that the keys and the values in the Map are numbers
Map.prototype.IsMonotonicallyDecreasing = 
	function()
	{
		var keys = Array.from(this.keys());
		return keys.every(key1 => keys.every(key2 => key1 >= key2 || this.get(key1) > this.get(key2)));
	}
	
var function1 = new Map([[1, 100], [4, 25], [5, 12]]);
console.log("Is the first function monotonically increasing? Answer: ", function1.IsMonotonicallyIncreasing());
console.log("Is the first function monotonically decreasing? Answer: ", function1.IsMonotonicallyDecreasing());

console.log("\n\n");

var function2 = new Map([[1, 100], [4, 250], [5, 1200]]);
console.log("Is the second function monotonically increasing? Answer: ", function2.IsMonotonicallyIncreasing());
console.log("Is the second function monotonically decreasing? Answer: ", function2.IsMonotonicallyDecreasing());

console.log("\n\n");

var function3 = new Map([[1, 100], [4, 25], [5, 120]]);
console.log("Is the third function monotonically increasing? Answer: ", function3.IsMonotonicallyIncreasing());
console.log("Is the third function monotonically decreasing? Answer: ", function3.IsMonotonicallyDecreasing());

console.log("\n\nPress ENTER to exit.");
process.stdin.setRawMode(true);
process.stdin.resume();
process.stdin.on('data', process.exit.bind(process, 0));
