import java.io.IOException;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.regex.Pattern;

class SecurityValidations
{  
	public static void main(String args[])
	{
		System.out.println("\n\n");

		TestUsername("_user");
		TestUsername("my.self");
		TestUsername("lucifer");
		TestUsername("test_user_123");
		TestUsername("too_many_letters_in_this_case");
		TestUsername("");

		System.out.println("\n\n");

		TestStrongPassword("Short.1");
		TestStrongPassword("OnlyLetters");
		TestStrongPassword("123456789");
		TestStrongPassword("almost123RR");
		TestStrongPassword("another.try");
		TestStrongPassword("P@ssw0rd");
		TestStrongPassword("succeSS-123");
		
		System.out.println("\n\nPress ENTER to exit.");
		try
		{
			BufferedReader systemInReader = new BufferedReader(new InputStreamReader(System.in));
			int enter = systemInReader.read();
		}
		catch(IOException exception)	{}
	}

	// A method that invokes the validation of the given username and prints the result
	static void TestUsername(String username)
	{
		System.out.printf("Is \"%s\" a valid username? Answer: %b.\n\n", username, ValidateUsername(username));
	}

	// A method that invokes the validation of the given password and prints the result
	static void TestStrongPassword(String password)
	{
		System.out.printf("Is \"%s\" a strong password? Answer: %b.\n\n", password, ValidateStrongPassword(password));
	}
	
	// Validate whether the input is a correct username
	static Boolean ValidateUsername(String username)
	{
		return Pattern.matches("^[a-zA-Z][\\w_]{5,15}$", username);
    }
		
	// Validate whether the input is a strong password
	static Boolean ValidateStrongPassword(String password)
	{
		return Pattern.matches("^(?=.*[A-Z])(?=.*[a-z])(?=.*\\d)(?=.*[\\.;\\-_!\\?@])[\\w\\.;\\-_!\\?@]{8,}$", password);
    }
} 
