console.log("\n\n");

var set1 = new Set([1, 3, 5, 7, 8, 9, 10]);
var set2 = new Set([2, 4, 6, 8, 10, 11]);

// Define extension method for union of the current set and a given other set
Set.prototype.Union = 
	function(otherSet)
	{
		return new Set([...this, ...otherSet]);
	}

// Test the union
console.log("The union of", set1, "and", set2, "is:");
console.log(set1.Union(set2));

console.log("\n\n");

// Define extension method for intersection of the current set and a given other set
Set.prototype.Intersection = 
	function(otherSet)
	{
		return new Set([...this].filter(element => otherSet.has(element)));
	}

// Test the intersection
console.log("The intersection of", set1, "and", set2, "is:");
console.log(set1.Intersection(set2));

console.log("\n\n");

// Define extension method for difference of the current set and a given other set
Set.prototype.Difference = 
	function(otherSet)
	{
		return new Set([...this].filter(element => !otherSet.has(element)));
	}

// Test the difference
console.log("The difference of", set1, "and", set2, "is:");
console.log(set1.Difference(set2));

console.log("\n\n");

// Define extension method for symmetric difference of the current set and a given other set
Set.prototype.SymmetricDifference = 
	function(otherSet)
	{
		return this.Difference(otherSet).Union(otherSet.Difference(this));
	}

// Test the symmetric difference
console.log("The symmetric difference of", set1, "and", set2, "is:");
console.log(set1.SymmetricDifference(set2));

console.log("\n\n");

// A method that intersects arbitrary many sets
function MultiIntersection()
{
	var minimalSizedSet = 
		[...arguments].reduce(
			function(aggregate, current) { return aggregate.size <= current.size ? aggregate : current; }, 
			arguments[0]);
	return 
		new Set([...minimalSizedSet].
			filter(element => [...arguments].every(set => set.has(element))));
}

// Test the multi intersection function
console.log("The intersection of the following ten sets is:",
	MultiIntersection(
		new Set([7, 5, 1, 22, 19, 21]), 
		new Set([5, 4, 0, 22, 7]), 
		new Set([65, 23, 10, 22, 7, 4, 13, 5, 78]), 
		new Set([22, 5, 8, 7]), 
		new Set([29, 34, 7, 20, 1, 5, 3, 22, 441]), 
		new Set([5, 6, 22, 7]), 
		new Set([7, 22, 9, 15, 86, 5, 27, 34]), 
		new Set([51, 49, 36, 5, 67, 81, 7, 111, 22]), 
		new Set([22, 7, 5, 10002, 775, 205]), 
		new Set([7, 234, 63, 1, 74, 4, 885, 3, 784, 22, 56, 888, 31, 9, 12, 63, 712, 1001, 5, 0])));

console.log("\n\nPress ENTER to exit.");
process.stdin.setRawMode(true);
process.stdin.resume();
process.stdin.on('data', process.exit.bind(process, 0));
