using System;
using System.Globalization;
using System.Text.RegularExpressions;

class StringValidations
{
	static void Main() 
	{
		Console.WriteLine("\n\n");
		
		string text = "This is an example of Yoda translation, which is being done with a simple translator. I will translate a few sentences. They include some examples that change during the translation. Also, there are sentences that do not change. All sentences after them will not be translated. I hope that you had fun.";
				
		Console.WriteLine("The original text is:\n\"{0}\"\n", text);
		
		Console.WriteLine("\n\n");
		
		Console.WriteLine("The Yoda translation is:\n\"{0}\"\n", YodaTranslate(text));		
		
		Console.WriteLine("\n\nPress ENTER to exit.");
		Console.ReadKey();
	}
	
	// Translate a given text into Yoda dialect (an improved version)
	static string YodaTranslate(string text) =>
		Regex.Replace(text, 
			@"\G(\s*)(i|you|he|she|it|we|they|this|that)\s+(\w+)\s+([^\.!\?;]*)\s*([\.!\?;])", 
			match => 
				match.Groups[1].Value + 
				char.ToUpper(match.Groups[4].Value[0]) + match.Groups[4].Value.Substring(1) + " " + 
				(match.Groups[2].Value.ToLower()  == "i" ? "I" : match.Groups[2].Value.ToLower()) + " " + 
				match.Groups[3].Value + 
				match.Groups[5].Value, 
			RegexOptions.IgnoreCase);
}
